const fs = require('fs');
const path = require('path');

const exec = require('child_process').execSync;

const scriptsLocation = path.join(__dirname, '../applescripts');
const vendorLocation = path.join(__dirname, '../vendor');

const exportImagesScriptLocation = path.join(scriptsLocation, 'export-images.applescript');
const exportKeynote09ScriptLocation = path.join(scriptsLocation, 'export-to-keynote-09.applescript');
const extractNotesScriptLocation = path.join(vendorLocation, 'mattisg/keynote-notes-extractor/extract_notes.sh');

module.exports = {
  extract: function (jobId, pathToFile) {

    // Extract images
    exec(`osascript ${exportImagesScriptLocation} "${pathToFile}" "${jobId}"`);

    // Extract presentation to Keynote 09 format
    exec(`osascript ${exportKeynote09ScriptLocation} "${pathToFile}" "${jobId}"`);

    // Rename presentation to zip
    exec(`mv /tmp/${jobId}/${jobId}.key /tmp/${jobId}/${jobId}.zip`);

    // Extract presentation archive to extracted directory
    exec(`unzip /tmp/${jobId}/${jobId}.zip -d /tmp/${jobId}/extracted`);

    // Take the index.apxl file out of the extracted content
    exec(`mv /tmp/${jobId}/extracted/index.apxl /tmp/${jobId}/`);

    // Extract notes
    exec(`${extractNotesScriptLocation} /tmp/${jobId}/index.apxl`);
  }
};
